function connectWebViewJavascriptBridge(callback) {
    if (window.WebViewJavascriptBridge) {
        callback(WebViewJavascriptBridge)
    } else {
        document.addEventListener(
           'WebViewJavascriptBridgeReady'
           , function() {
               callback(WebViewJavascriptBridge)
           }, false);
    }
}

// java调用js第一连接时初始化bridage
connectWebViewJavascriptBridge(function(bridge) {
    bridge.init(function(message, responseCallback) {
        console.log('JS got a message', message);
        var data = {
           'Javascript Responds': '测试中文!'
        };
        console.log('JS responding with', data);
        responseCallback(data);
    });

    bridge.registerHandler("lazyLoadFirstPic", function(data, responseCallback) {
        lazyLoadImg();
        checkCommentHeight();
    });

    bridge.registerHandler("updatePic", function(data, responseCallback) {
        var ids = data.split(";");
        var name = ids[0];
        var path = ids[1];
        var srcName = document.getElementsByName(name);
        for(var i = 0;i < srcName.length; i++) {
            if(isScreen(srcName[i])) {
                var tempSrc = srcName[i].src;
                if(tempSrc !== path) {
                    srcName[i].src = path;
                    // 清掉对应的标志，避免下次还去上传url去下载图片,不能全部置为空，会影响到头像的样式，头像带有两个 class 的。
                    srcName[i].className = srcName[i].className.replace("lazy-img", "");
                }
            }
        }

    });

     bridge.registerHandler("updateAvatar", function(data, responseCallback) {
         var ids = data.split(";");
         var name = ids[0];
         var path = ids[1];
         var srcName = document.getElementsByName(name);
         for(var i = 0;i < srcName.length; i++) {
             srcName[i].src = path;
         }
     });


     bridge.registerHandler("insertHotComment", function(data, responseCallback) {
         var obj=JSON.parse(data);
         $("#hotCommentBox").css('display','block');
         $("#hotReplyCount").text('('+obj.count+')');
         var listDiv = document.getElementById("hotLoading");
         if (listDiv) {
             listDiv.insertAdjacentHTML("beforeBegin",decodeURIComponent((obj.content).replace(/\+/g, '%20')));
         }
     });

     bridge.registerHandler("updateCommentCount",function(data,responseCallback){
        $('#allCommentCount').text('('+data+')');
     });


     bridge.registerHandler("updateNoteComment",function(data,responseCallback){
            var obj=JSON.parse(data);
            var floorIndex=obj.floorIndex;
            var commentHtml= decodeURIComponent((obj.commentHtml).replace(/\+/g, '%20'));
            var commentCount=obj.commentCount;
            var deckList=$("#floor"+floorIndex +" ul.deck-list");
            $(deckList).html(commentHtml);
            $(deckList).show();
            var moreDiv=$("#floor"+floorIndex +" div#more"+floorIndex);
            var firstA=moreDiv.find('a')[0];
            $(firstA).bind("click",function(){
                this.setAttribute("showall","0");
                showMoreComment(this,floorIndex,floorIndex,commentCount);
            });
            $(firstA).text('全部'+commentCount+'条评论');
            if(commentCount>2){
                $(moreDiv).show();
            }
     });

     bridge.registerHandler("hideCommentLoadingMore",function(data,responseCallback){
            $("#reply-list #loading").hide();
     });
})

function changeStyle(mode) {
    var obj = document.getElementById("css");
    var cssFileName = "css/"+mode+"_style.css";
    obj.setAttribute("href",cssFileName);
}

function isReadyForPullDown() {
    var result = document.body.scrollTop == 0;
    ptr.isReadyForPullDownResponse(result);
}

function isReadyForPullUp() {
    var result = document.body.scrollTop + window.innerHeight >= document.body.scrollHeight;
    ptr.isReadyForPullUpResponse(result);
}

function nightModeChange(isNightMode) {
     if (isNightMode == 'skin-night') {
          document.getElementsByTagName('body')[0].className = "skin-night";
     } else {
          document.getElementsByTagName('body')[0].className = "";
     }
}