/** 
* @fileOverview 触屏版的图片延迟加载
* @author kunerzhang 
* @version 2.0 
* @date 2013-4-15
*/

TY.loadedModule('TY.m.lazyload');
TY.ns('TY.m.lazyload',function(){
	var screen_h =  document.documentElement.clientHeight;
	var offset=100;
	var is_scroll=false;
	var imgs=[];
	var data_src="data-src";
	var delay=200;
	
	function getScrollTop(doc){
		var _doc = doc || document;		
		if(TY.os&&TY.os.ios){
			return parseInt(window.scrollY,10);		
		}else{
			return Math.max(_doc.documentElement.scrollTop, _doc.body.scrollTop);
		}
	}
	function bindEvent(){
		if(!is_scroll){
			if(TY.os&&TY.os.ios){
				TY(document.body).bind('touchend',loadImg);
			}else{
				TY(window).bind('scroll',loadImg);
			}
			TY(window).bind('resize',loadImg);
			is_scroll=true;
		}
	}
	function unBindEvent(){
		if(is_scroll){
			if(TY.os&&TY.os.ios){
				TY(document.body).unbind('touchmove',loadImg).unbind('touchend',loadImg);
			}else{
				TY(window).unbind('scroll',loadImg);
			}
			TY(window).unbind('resize',loadImg);
			is_scroll=false;
		}
	}
	function load(){
		var t=0,l,h,st=getScrollTop(),img,$img,i=0;
		screen_h =  document.documentElement.clientHeight;
	  	if(imgs&&(l=imgs.length)){	
			while((l=imgs.length) && i<l){
			//console.log(i+":"+l)
				img = imgs[i];$img = TY(img);
				t=parseInt($img.offset().top,10);
				
				h = parseInt($img.height(),10)||screen_h ;
				if(t>st+screen_h){
					//break;
				}else if(t> st-h){
					var src = $img.attr(data_src);
					if(src){
						img.src = src;
					}
	  				imgs.splice(i--,1);
					img.removeAttribute(data_src);
	  			}
				i++;
			}
	  	}else{
			unBindEvent();
		}
	}
	function loadImg(){
	  	setTimeout(load,delay);
	}
	 /**
     * 延迟加载图片加载图片
     * @param	{String} selector img的容器选择器例如"#img_div img"
     * @param	{String}	pic	  图片的默认占位符
	 * @param	{String}	name  图片路径的属性名称，默认为data_src
	 * @param 	{String} err_src  当图片加载失败时的替换图片连接，默认/resources/images/error.gif
     * @example TY.m.lazyload.load("#img_div","default.jpg","init-src"，"err_pic.jpg");
     */
	this.load=function(selector,pic,name,err_src,seconds){
		selector = selector ? selector : "";
		data_src = name || data_src;
		err_src =err_src ||TY.isDebuger()+"/resources/images/error.gif";
		delay = seconds || seconds;
		TY(selector).each(function(i){
		  	if(TY(this).attr(data_src)){
				imgs.push(this);
				if(pic){
					this.src=pic;
				}
				if(err_src){
					this.onerror=function(){
						this.src=err_src ;
					}
				}
		  	}
			
		 });
		loadImg();
		bindEvent();
	}
})