(function () {
    // 浏览器判断
    var browser = {
            versions: function () {
                var u = navigator.userAgent;
                return {//移动终端浏览器版本信息
                    trident: u.indexOf("Trident") > -1, //IE内核
                    presto: u.indexOf("Presto") > -1, //opera内核
                    webKit: u.indexOf("AppleWebKit") > -1, //苹果、谷歌内核
                    gecko: u.indexOf("Gecko") > -1 && u.indexOf("KHTML") == -1, //火狐内核
                    mobile: !!u.match(/AppleWebKit.*Mobile.*/), //是否为移动终端
                    ios: !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/), //ios终端
                    android: u.indexOf("Android") > -1 || u.indexOf("Linux") > -1, //android终端或者uc浏览器
                    iPhone: u.indexOf("iPhone") > -1, //是否为iPhone或者QQHD浏览器
                    iPad: u.indexOf("iPad") > -1, //是否iPad
                    webApp: u.indexOf("Safari") == -1 //是否web应该程序，没有头部与底部
                };
            }(),
            language: (navigator.browserLanguage || navigator.language).toLowerCase()
        },
    // 局部滚动处理
        partScroll = function (el) {
            var startX, startY;

            $(el).on('touchstart', function (event) {
                startX = event.changedTouches[0].pageX;
                startY = event.changedTouches[0].pageY;
            });

            $(el).on('touchmove', function (event) {
                var deltaX, deltaY;

                event.stopPropagation();
                deltaX = event.changedTouches[0].pageX - startX;
                deltaY = event.changedTouches[0].pageY - startY;

                // 只能纵向滚
                if (Math.abs(deltaY) < Math.abs(deltaX)) {
                    event.preventDefault();
                    return false;
                }

                if ($(this).height() + $(this).scrollTop() >= $(this)[0].scrollHeight) {
                    if (deltaY < 0) {
                        event.preventDefault();
                        return false;
                    }
                }

                if ($(this).scrollTop() === 0) {
                    if (deltaY > 0) {
                        event.preventDefault();
                        return false;
                    }
                }
            });
        },
    //获取 el在 body 上的位置
        getPosition = function (option) {
            var el = option,
                x = 0,
                y = 0;

            do {
                x += el.offsetLeft;
                y += el.offsetTop;
            } while (el = el.offsetParent);  //若 el 的上层元素为绝对定位，则 el.offsetParent 为该元素；如没定位，追溯到上层定位元素，直至到 body
            return {
                x: x,
                y: y
            }
        };

    partScroll('.quote-content');


    /*-------- 事件 --------*/
    // 下拉框 复制&举报
    $('.content').on('click', '.arrow', function (event) {
        event.stopPropagation();
        $('.arrow').removeClass('active');
        $(this).addClass('active');
    }).
        on('touchstart', 'a', function (event) {
            event.stopPropagation();
        }).
        // 引用原文展开
        on('click', '.quote', function () {
            if($(this).hasClass('open')){
                $(this).removeClass('open');
                callAppFun('tianya://originalContentDisplayOff');
//                document.location = 'tianya://originalContentDisplayOff';
            } else{
                $(this).addClass('open');
//                document.location = 'tianya://originalContentDisplayOn';
                callAppFun('tianya://originalContentDisplayOn');
            }
        }).
        on('touchmove', '.quote', function (event) {
            event.preventDefault();
        }).
        // 必火 +1动画
        on('click', '.vote', function () {
            var $this = $(this);

            if (!$this.hasClass('active')) {
                $this.find('span').addClass('vote-shrink');
                setTimeout(function () {
                    $('.hot').find('a').addClass('active');
                }, 500);
            }
        });
//       // 点击加载
//       on('click', '.loading', function () {
////          document.location = 'tianya://clickToShowMoreContent';
//           callAppFun('tianya://clickToShowMoreContent');
//          });
                                   
    // 复制&举报 关闭弹窗
    $('.arrow').on('click', 'a', function (event) {
        event.stopPropagation();
        $('.arrow').removeClass('active');
    });

    $('body').bind('touchstart', function () {
        $('.arrow').removeClass('active');
    }).
        // 返回顶部
        on('touchstart', '.go-top', function (event) {
            event.preventDefault();
            $(window).scrollTop(0);
        });

    // 评论页展开更多
    $('.comment-box').on('click', '.more', function(){
        $('.comment-text').addClass('open');
        $(this).hide();
    });

    // 返回顶部
    $(window).bind('scroll', function () {
//        var $goTop = $('.go-top');
//
//        if (browser.versions.android) {
//            if ($(this).scrollTop() > 100) {
//                if ($goTop.length) {
//                    $goTop.show();
//                } else {
//                    $('body').append('<a class="go-top" href="javascript:;"></a>');
//                }
//            } else {
//                $goTop.hide();
//            }
//        }

        // 图片懒加载
        lazyLoadImg();
    });


    // 图片懒加载
    window.lazyLoadImg = function () {
        console.log('JS got a message lazyLoadImg ');
        var $item = $('.lazy-img'),
            scaleH = window.innerHeight;

        $item.each(function () {
            var top = $(this).offset().top,
                src = $(this).data('src');

            // 滚动到2屏内，开始加载对应的img
            if (top < scaleH * 2 + $(window).scrollTop()) {
            // Android 不能用 location 的方式去加载图片， 会导致上层 shouldOverrideUrlLoading 快速取的时候，每次只能取到第三个，前面两个就漏掉了。
//                document.location = 'tianya://downloadImage?url=' + src;
                if(isScreen(this)) {
                    var url = 'tianya://downloadImage?url=' + src;
                    callAppFun(url);
                }
            }
        });
    };


    // 判读图片是否在当前屏
    // param: el 选择器
    window.isScreen = function (el) {
        var elTop = getPosition(el).y,
            scaleH = window.innerHeight,
            scrollTop = document.documentElement.scrollTop || document.body.scrollTop;

        if (elTop < scrollTop + scaleH && elTop > scrollTop - el.height) {
            return true;
        }
        return false;
    };

    //正文推荐图标动画
    window.showVoteAnimated = function (){
        $('#voteActive').addClass('active');
    }

    //楼层点赞图标动画
    window.showAgreeAnimated = function (index) {
        var srcName = document.getElementsByName(index),
            em;
        for(var i = 0;i < srcName.length; i++) {
            srcName[i].className = srcName[i].className.replace("agree-btn", "agree-btn active amplify");

            em = srcName[i].querySelector('em');
            em.innerText = +em.innerText + 1;

           srcName[i].href = "tianya://agree?floor=0&success=1";
        }
    }


})();